<?php

	$prefix    = "gs1085";
	$w_gutter  =  8; // px.
	$w_column  = 40; // px.
	$w_gap     = 15; // px.
	$w_padding = 15; // px.
	$n_columns = 20;

	dygrid( $prefix, $w_gutter, $w_column, $w_gap, $w_padding, $n_columns );

?>
<?php

function dygrid( $prefix, $w_gutter, $w_column, $w_gap, $w_padding, $n_columns )
{
	header( 'Content-type: text/css' );

	println( "/* Dygrid | Dynamic Grid Generator */" );
	println();

	printWidths  ( $prefix, $w_column, $w_gap, $n_columns, $w_gutter );
	printSpans   ( $prefix, $w_column, $w_gap, $n_columns );
	printOffsets ( $prefix, $w_column, $w_gap, $n_columns );
	printElements( $prefix, $w_column, $w_gap, $n_columns, $w_padding );
}

function printWidths( $prefix, $w_column, $w_gap, $n_columns, $w_gutter )
{
	$c = ($w_column * $n_columns) + ($w_gap * ($n_columns - 1));
	$p = $c + (2 * $w_gutter );

	println( sprintf( "%10s %14s { width:%s; }", ".$prefix", ".c_width ", $c . "px" ) );
	println( sprintf( "%10s %14s { width:%s; }", ".$prefix", ".p_width ", $p . "px" ) );
	println();
}

function printSpans( $prefix, $w_column, $w_gap, $n_columns )
{
	println( sprintf( "%10s .row:before, .$prefix .row:after { display:table; content:''; }", ".$prefix" ) );
	println( sprintf( "%10s .row:after                       { clear:both;                }", ".$prefix" ) );
	println();

	println( sprintf( "%10s %14s { margin-left:%6s; }", ".$prefix", ".row  ", "-" . $w_gap . "px" ) );
	println( sprintf( "%10s %14s { margin-left:%6s; }", ".$prefix", ".span ",       $w_gap . "px" ) );
	println( sprintf( "%10s %14s { float:left; }",      ".$prefix", ".span " ) );

	println();

	for ( $i=1; $i <= $n_columns; $i++ )
	{
		$w = spanWidth( $w_column, $w_gap, $i );
	
		println( sprintf( "%10s %14s { width:%8s }", ".$prefix", ".span$i", "$w" . "px;" ) );
	}
}

function printOffsets( $prefix, $w_column, $w_gap, $n_columns )
{
	println();

	for ( $i=1; $i <= $n_columns; $i++ )
	{
		$w = offsetWidth( $w_column, $w_gap, $i );
	
		println( sprintf( "%10s %14s { margin-left:%8s }", ".$prefix", ".offset$i", "$w" . "px;" ) );
	}
}

function printElements( $prefix, $w_column, $w_gap, $n_columns, $w_padding )
{
	printTextFields( $prefix, $w_column, $w_gap, $n_columns, $w_padding );
	printButtons   ( $prefix, $w_column, $w_gap, $n_columns, $w_padding );
}

function printTextFields( $prefix, $w_column, $w_gap, $n_columns, $w_padding )
{
	println();

	for ( $i=1; $i <= $n_columns; $i++ )
	{
		$w = spanWidth( $w_column, $w_gap, $i ) - ($w_padding * 2);
	
		println( sprintf( "%10s %14s { width:%8s }", ".$prefix", ".text.span$i", "$w" . "px;" ) );
	}
}

function printButtons( $prefix, $w_column, $w_gap, $n_columns, $w_padding )
{
//	println();
//
//	for ( $i=1; $i <= $n_columns; $i++ )
//	{
//		$w = spanWidth( $w_column, $w_gap, $i ) - ($w_padding * 2);
//	
//		println( sprintf( "%10s %14s { width:%8s }", ".$prefix", ".button.span$i", "$w" . "px;" ) );
//	}
}






function spanWidth( $w_column, $w_gap, $i )
{
	return ($i * $w_column) + (($i-1) * $w_gap);
}

function offsetWidth( $w_column, $w_gap, $i )
{
	return ($i * $w_column) + ($i * $w_gap) + $w_gap;
}

function println( $str = "" )
{
	echo( $str . "\n" );
}

?>
